unit PlaySnd;
{--------------------------------------------------}
                     interface
{--------------------------------------------------}

procedure PrepareForOutput(Freq:word);
procedure PlaySound(var Buffer; Size:word);
procedure FinishOutput;
const
  MaskInterrupts:boolean=true;
{--------------------------------------------------}
                  implementation
{--------------------------------------------------}
var
  Old8h:pointer;

procedure PlaySound(var Buffer; Size:word);assembler;

asm
	cli
        cmp MaskInterrupts,true
        jne @NoMask
        in al,21h
        mov bl,al
        mov al,0feh
        out 21h,al
@NoMask:xor si,si
        xor ax,ax
        mov es,ax

        mov ax,word ptr es:[20h]
        mov word ptr Old8h,ax
        mov ax,word ptr es:[22h]
        mov word ptr Old8h+2,ax

        mov word ptr es:[20h],offset @Timer
        mov word ptr es:[22h],seg @Timer
        les bx,Buffer
        sti

@Next:	cmp si,Size
	jne @Next

        cli
        xor ax,ax
        mov es,ax
        mov ax,word ptr Old8h
        mov word ptr es:[20h],ax
        mov ax,word ptr Old8h+2
        mov word ptr es:[22h],ax
        cmp MaskInterrupts,true
        jne @NM
        mov al,bl
        out 21h,al
@NM:	sti
        jmp @Quit

@Timer: cmp si,Size
        je @Exit
        mov al,es:[bx][si]
        shr al,1
    	out 42H,al
        inc si
@Exit:  mov al,20h
        out 20h,al
        iret
@Quit:
end;

procedure PrepareForOutput(Freq:word);
var
  Count:word;

begin
  Count:=1193180 div Freq;
  asm
	   cli
	   mov	al,00110110b
			      { bit 5,4 = (11) write LSB then MSB}
			      { bit 3-1 = (011) generate square wave}
			      { bit 0 = (0) binary counter}
	   out	43h,al	      { prep PIT, counter 0, square wave&init count}
	   mov	cx,Count      { default is 0x0000 (65536) (18.2 per sec)}
			      { interrupts when counter decrements to 0}
	   mov	al,cl	      { send LSB of timer count}
	   out	40h,al
	   mov	al,ch	      { send MSB of timer count}
	   out	40h,al

           mov al,0b0h
           out 43h,al
           mov al,1
           out 42h,al
           dec al
           out 42h,al

           mov al,90h
           out 43H,al
           in al,61h
           or al,3
           out 61H,al
           sti
  end;
end;

procedure FinishOutput;assembler;
asm
        cli
        in al,61h
        and al,0fch
        out 61h,al

	mov al,00110110b
	out 43h,al
	xor al,al
	out 40h,al
	out 40h,al
        sti
end;

end.